# Tutorials

* [gamedev tuts+][]: lot of usefull articles
* [Math for Game Developers](http://www.youtube.com/playlist?list=PLW3Zl3wyJwWOpdhYedlD-yCB7WQoHf-My) from youtube channel of [Jorge Rodriguez](http://www.youtube.com/user/BSVino)
* [gamedev.net](http://www.gamedev.net/) section about [Math and Physics](http://www.gamedev.net/page/resources/_/technical/math-and-physics/)
  * [Vectors and Matrices: A Primer](http://www.gamedev.net/page/resources/_/technical/math-and-physics/vectors-and-matrices-a-primer-r3064)
  * [3D Matrix Math Demystified](http://www.gamedev.net/page/resources/_/technical/math-and-physics/3d-matrix-math-demystified-r695)
 
# Inspirations

## Particles

* [sparks.js](https://github.com/zz85/sparks.js/) : a lightweight 3d particle engine in javascript, compatible with [THREE.js](https://github.com/mrdoob/three.js) and [Tween.js](https://github.com/sole/tween.js/)
* [FLiNT particles system](http://flintparticles.org/) : a 2D/3D particule system for Action Script
* [Make Your Game Pop With Particle Effects and Quadtrees](http://gamedev.tutsplus.com/tutorials/implementation/make-your-game-pop-with-particle-effects-and-quadtrees/) from [gamedev tuts+][]
* [Advanced Character Physics](http://www.gamasutra.com/view/feature/131313/advanced_character_physics.php): how to use verlet for physics
* [verlet.js](https://github.com/subprotocol/verlet-js) : a verlet simulator for javascript
* [Simulate Tearable Cloth and Ragdolls With Simple Verlet Integration](http://gamedev.tutsplus.com/tutorials/implementation/simulate-fabric-and-ragdolls-with-simple-verlet-integration/) from [gamedev tuts+][]

## Easing

* [Robert Penner's Easing Functions](http://www.robertpenner.com/easing/)
* [Interpolation Tricks](http://sol.gfxile.net/interpolation/)
* [Tween.js](https://github.com/sole/tween.js/)
* [Stage XL](http://www.stagexl.org/) [Transitions](http://www.stagexl.org/docs/transitions.html)

## Collisions

* [Quick Tip: Use Quadtrees to Detect Likely Collisions in 2D Space](http://gamedev.tutsplus.com/tutorials/implementation/quick-tip-use-quadtrees-to-detect-likely-collisions-in-2d-space/) from [gamedev tuts+][]
* [Quadtree](http://en.wikipedia.org/wiki/Quadtree) from [wikipedia][] 
* [How to make a 2d platform game – part 2 collision detection](http://www.wildbunny.co.uk/blog/2011/12/14/how-to-make-a-2d-platform-game-part-2-collision-detection/) from [Paul's blog@Wildbunny][]
* [Speculative Contacts – a continuous collision engine approach](http://www.wildbunny.co.uk/blog/2011/03/25/speculative-contacts-an-continuous-collision-engine-approach-part-1/) from [Paul's blog@Wildbunny][]
* [N Tutorial A - Collision Detection and Response](http://www.metanetsoftware.com/technique/tutorialA.html) from [Metanet Software Inc](http://www.metanetsoftware.com/)

## Languages (code style)

* [Scala] for the mix of OOP and functionnal

## framework

* [Unity3D's Components](http://docs.unity3d.com/Documentation/ScriptReference/Component.html)
* [toxiclibs](http://toxiclibs.org/about/) : library collection for computational design tasks with Java & [Processing](http://processing.org/)

  [gamedev tuts+]: http://gamedev.tutsplus.com/
  [Paul's blog@Wildbunny]: http://www.wildbunny.co.uk/blog/
  [wikipedia]: http://en.wikipedia.org/